<template>
  <div class="row ml-5 mr-1">
    <div class="col-7">
      <form
        @submit.prevent="pesquisar"
        class="form-inline d-flex justify-content-center md-form form-sm mt-4"
      >
        <input
          v-model="pesquisa"
          class="form-control form-control-sm mr-1 col-6"
          type="text"
          placeholder="Filtrar Produtos"
          aria-label="Search"
        />

        <button class="btn-sm btn-info" type="submit">
          <i class="fas fa-search" aria-hidden="true"></i>
        </button>
      </form>
      Listagem de Produtos
      <table class="table table-striped">
        <thead>
          <tr>
            <th>Produto</th>
            <th>Marca</th>
            <th>Venda</th>
            <th>Estoque</th>
            <th>Quantidade</th>
            <th class="text-center">Adicionar</th>
          </tr>
        </thead>
        <tbody v-if="produtos">
          <tr v-for="produto in produtos" v-bind:key="produto.id">
            <td>{{ produto.nome }}</td>
            <td>
              {{
                marcas &&
                marcas[produto.marca_id - 1] &&
                marcas[produto.marca_id - 1].nome
              }}
            </td>
            <td>R$ {{ produto.valor_venda | estiloMoeda }}</td>
            <td>{{ produto.quant }}</td>
            <vue-numeric-input
              id="quant"
              align="center"
              v-model="produto.quant_compra"
              :max="produto.quant"
              :min="0"
            ></vue-numeric-input>

            <td class="text-center">
              <button
                class="btn btn-sm btn-success"
                title="Adicionar ao Carrinho"
                @click="adicionar(produto)"
              >
                <i class="fas fa-plus"></i>
              </button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div id="carrinho" class="col-5">
      <form @submit.prevent="salvar">
        Carrinho de Compras
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Produto</th>
              <th>Quantidade</th>
              <th>Valor Unid.</th>
              <th>Valor Total</th>
              <th class="text-center">Remover</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="carrinho in carrinho" v-bind:key="carrinho.id">
              <td>{{ carrinho.nome }}</td>
              <th>{{ carrinho.quant_compra }}</th>
              <td>R$ {{ carrinho.valor_venda | estiloMoeda }}</td>
              <td>
                R$ {{ (carrinho.valor_venda * carrinho.quant_compra) | estiloMoeda }}
              </td>
              <td class="d-flex justify-content-center">
                <button
                  class="btn btn-sm text-danger d-flex"
                  title="Remover do Carrinho"
                  @click="remover(carrinho)"
                >
                  <i class="fas fa-trash"></i>
                </button>
              </td>
            </tr>
          </tbody>
        </table>
          <div class="text-center" style="border-bottom: 1px #3CB521 solid">
            <h3 class="text" id="valortotal">
              R$ {{ pedido.valor_pedido = valorTotal | estiloMoeda }}
            </h3>
          </div>
        <div class="d-flex justify-content-end">
          <button @click="modalPagamento=!modalPagamento" type="submit" class="btn btn-success mt-10 t-white text-center">FINALIZAR VENDA</button>
        </div>
        <vs-dialog class="" width="700px" prevent-close not-close not-center v-model="modalPagamento">
          <template #header>
            <h4 class="not-margin">
              <b>Pagamento do pedido </b>
            </h4>
          </template>
          <div class="d-flex justify-content-end" style="margin-top: -60px">
            <button class="btn-gray btn f-13 m-pag t-white text-center" @click="pagamento = !pagamento">Alterar forma de pagamento</button>
          </div>
          <div class="d-flex justify-content-end t-black">
            <div v-if="pagamento === false" style="margin-right: 15px">
                <b>Cartão de crédito/débito</b>
            </div>
            <div v-else style="margin-right: 70px">
              <b>Dinheiro</b>
            </div>
          </div>
          <div class="container pd-20"> 
            <div class="d-flex justify-content-between border-1" >
              <div class="bold">Valor total:</div>
              <div class="col-4 bold style-input t-black" type="text" >
                <input disabled type="text" class="bold style-input" style="border: 0; color: #000;" name="" id="valor_total" v-bind:value="valorTotal | estiloMoeda" >
              </div>
            </div> 
            <div class="d-flex justify-content-between border-1" v-if="pagamento === true" >
              <div class="bold">Valor pago:</div>
              <input autocomplete="off" class="col-4 bold style-input" style="background: #FFF" id="valor_pago" type="text" v-on:keyup="calculo()" value="">
            </div> 
            <div class="d-flex justify-content-between border-1" v-if="pagamento === true" >
              <div class="bold">Troco:</div>
              <div class="col-4 bold style-input t-black" type="text">
                <input disabled type="text" class="bold style-input" style="border: 0; color: red;" name="" id="troco" v-bind:value="''" >
              </div>
            </div> 
          </div>
          <template #footer>
            <div class="con-footer center">
              <router-link to="/listagempedidos" class="btn btn-gray mt-10 t-white text-center mr">
                Cancelar
              </router-link>
              <router-link to="/listagempedidos"  class="btn-pedido btn btn-success mt-10 t-white text-center">
                Finalizar pedido
              </router-link>
            </div>
          </template>
        </vs-dialog>
      </form>
    </div>
  </div>
</template>
<script>
import axios from "axios";
export default {
  data() {
    return {
      modalPagamento: false,
      pagamento: true,
      clientes: [],
      marcas: [],
      produtos: [
        {
          id: null,
          nome: null,
          marca_id: null,
          quant: null,
          quant_compra: 0,
          valor_venda: 0,
        }
      ],
      pesquisa: "",
      carrinho: [],
      pedido: {
        id: null,
        status: 'aberto',
        valor_pedido: ''
      }
    };
  },
  methods: {
    reload() {
      this.modalPagamento=false
      setTimeout(() => {
        window.location.reload()
      }, 500);
    },
    calculo(){ 
      $("#troco").val(($("#valor_pago").val() - $("#valor_total").val()).toFixed(2))
    }, 
    listar() {
      if (localStorage.getItem("token")) {
        axios.get(this.$urlAPI + "/produtos").then((response) => {
          this.produtos = [];
          response.data.map((item) => {
            item.quant_compra = 0;
            this.produtos.push(item);
          });
        });
        axios
          .get(this.$urlAPI + "/listamarcas")
          .then((response) => (this.marcas = response.data));
      }
    },
    adicionar(produto) {
      if (produto.quant_compra == 0) {
        return;
      }
      const produtoCarrinho = this.carrinho.find((item) => item.id == produto.id);
      if (!produtoCarrinho) {
        this.carrinho.push(Object.assign({}, produto));

        return;
      }
      const somaProdutoCarrinho =
        produtoCarrinho.quant_compra + produto.quant_compra;
      if (somaProdutoCarrinho <= produto.quant) {
        produtoCarrinho.quant_compra = somaProdutoCarrinho;
      } else {
        alert("Produto em quantidade inferior no estoque.");
      }
    },
    remover(produto) {
      this.carrinho = this.carrinho.filter((item) => item !== produto);
    },
    pesquisar() {
      if (this.pesquisa.length == 0) {
        this.listar();
      } else {
        console.log(this.pesquisa);
        axios
          .get(this.$urlAPI + `/busca/${this.pesquisa}`)
          .then((response) => (this.produtos = response.data));
      }
    },
    async salvar() {
      let valorTotal = this.valorTotal
      if (this.valorTotal == 0) {
        alert("Carrinho vazio");
      } else {
        let produto_id = [];
        let resp = await axios.post(this.$urlAPI + "/pedido", this.pedido)
        this.carrinho.forEach(element => {
          let item = {
            produto_id: element.id,
            quant_compra: element.quant_compra, 
            pedido_id: resp.data.id,
          }
          // console.log(item)
          axios.post(this.$urlAPI + "/carrinho", item)
          let produto = {
            id: item.produto_id,
            quant: item.quant_compra
          }
          console.log(produto);
          axios.put(this.$urlAPI + "/produtos", produto)
          produto_id = this.produtos.filter(function(obj) {return obj.id == item.produto_id})[0].id
        })
        let pedido = {
          id: resp.data.id,
          status: "fechado",
          valor_pedido: valorTotal,
        }
        await axios.put(this.$urlAPI + "/pedido", pedido)
      }
    },
  },
  computed: {
    valorTotal() {
      if (!this.carrinho) {
        return;
      }
      let total = 0;
      this.carrinho.map((item) => {
        total = total + (item.valor_venda * item.quant_compra);
      });
      return total.toFixed(2);
    },
  },
  mounted() {
    this.listar();
    if (localStorage.getItem("token")) {
      axios
        .get(this.$urlAPI + `/clientes`)
        .then((response) => (this.clientes = response.data));
    }
  },
  filters: {
    estiloMoeda(value) {
      return value.toLocaleString("pt-br", { minimumFractionDigits: 2 });
    },
  },
};
</script>

<style scoped>
#carrinho {
  margin-top: 55px;
}
#quant {
  margin-top: 14px;
}
#valortotal {
  margin-top: 10px;
}
.mr{
 margin-right: 5px;
}
.f-13 {
  font-size: 13px;
}
.center{ 
  display: flex;
  justify-content: center;
}
.btn-pedido {
  width: 70%;
  background: #349c1c;
}
.btn-gray {
  width: 30%;
  background: silver;
}
.t-white {
   color: white;
}
.t-black{ 
  color: black;
}
.mt-10 {
   margin-top: 10px; 
}
.m-pag{
  margin-bottom: 10px;
  margin-right: 12px;
}
.bold{
  font-weight: bold;
}
.pd-20 {
  padding: 20px;
}
.style-input {
  border: 0px;
  border-bottom: 1px solid rgb(0, 0, 0);
  text-align: center;
}
.border-1{ 
  border-bottom: 1px solid silver;
  margin-bottom: 30px;
}
</style>